# GeometryUpdater - Cesium Documentation

# GeometryUpdater

#### new Cesium.GeometryUpdater(entity, scene)
DataSources/GeometryUpdater.js 30

  Defines the interface for a geometry updater. A GeometryUpdater maps geometry defined as part of a `Entity` into `Geometry` instances. These instances are then visualized by `GeometryVisualizer`. This type defines an interface and cannot be instantiated directly.

  Name | Type | Description
  --- | --- | ---
  `entity` | Entity | The entity containing the geometry to be visualized.
  `scene` | Scene | The scene where visualization is taking place.

  ##### See:

  - EllipseGeometryUpdater
  - EllipsoidGeometryUpdater
  - PolygonGeometryUpdater
  - PolylineGeometryUpdater
  - RectangleGeometryUpdater
  - WallGeometryUpdater

### Members

#### staticCesium.GeometryUpdater.materialAppearanceType : Appearance
DataSources/GeometryUpdater.js 48

  Gets the type of Appearance to use for material-based geometry.

#### staticCesium.GeometryUpdater.perInstanceColorAppearanceType : Appearance
DataSources/GeometryUpdater.js 40

  Gets the type of Appearance to use for simple color-based geometry.

#### readonlyentity : Entity
DataSources/GeometryUpdater.js 61

  Gets the entity associated with this geometry.

#### readonlyfillEnabled : Boolean
DataSources/GeometryUpdater.js 71

  Gets a value indicating if the geometry has a fill component.

#### readonlyfillMaterialProperty : MaterialProperty
DataSources/GeometryUpdater.js 91

  Gets the material property used to fill the geometry.

#### readonlygeometryChanged : Boolean
DataSources/GeometryUpdater.js 166

  Gets an event that is raised whenever the public properties of this updater change.

#### readonlyhasConstantFill : Boolean
DataSources/GeometryUpdater.js 81

  Gets a value indicating if fill visibility varies with simulation time.

#### readonlyhasConstantOutline : Boolean
DataSources/GeometryUpdater.js 111

  Gets a value indicating if outline visibility varies with simulation time.

#### readonlyisClosed : Boolean
DataSources/GeometryUpdater.js 155

  Gets a value indicating if the geometry is closed. This property is only valid for static geometry.

#### readonlyisDynamic : Boolean
DataSources/GeometryUpdater.js 144

  Gets a value indicating if the geometry is time-varying. If true, all visualization is delegated to the `DynamicGeometryUpdater` returned by GeometryUpdater#createDynamicUpdater.

#### readonlyoutlineColorProperty : Property
DataSources/GeometryUpdater.js 121

  Gets the `Color` property for the geometry outline.

#### readonlyoutlineEnabled : Boolean
DataSources/GeometryUpdater.js 101

  Gets a value indicating if the geometry has an outline component.

#### readonlyoutlineWidth : Number
DataSources/GeometryUpdater.js 132

  Gets the constant with of the geometry outline, in pixels. This value is only valid if isDynamic is false.

### Methods

#### createDynamicUpdater(primitives) → DynamicGeometryUpdater
DataSources/GeometryUpdater.js 236

  Creates the dynamic updater to be used when GeometryUpdater#isDynamic is true.

  Name | Type | Description
  --- | --- | ---
  `primitives` | PrimitiveCollection | The primitive collection to use.

  ##### Returns:

  The dynamic updater used to update the geometry each frame.

  ##### Throws:

  - DeveloperError : This instance does not represent dynamic geometry.

#### createFillGeometryInstance(time) → GeometryInstance
DataSources/GeometryUpdater.js 198

  Creates the geometry instance which represents the fill of the geometry.

  Name | Type | Description
  --- | --- | ---
  `time` | JulianDate | The time to use when retrieving initial attribute values.

  ##### Returns:

  The geometry instance representing the filled portion of the geometry.

  ##### Throws:

  - DeveloperError : This instance does not represent a filled geometry.

#### createOutlineGeometryInstance(time) → GeometryInstance
DataSources/GeometryUpdater.js 209

  Creates the geometry instance which represents the outline of the geometry.

  Name | Type | Description
  --- | --- | ---
  `time` | JulianDate | The time to use when retrieving initial attribute values.

  ##### Returns:

  The geometry instance representing the outline portion of the geometry.

  ##### Throws:

  - DeveloperError : This instance does not represent an outlined geometry.

#### destroy()
DataSources/GeometryUpdater.js 225

  Destroys and resources used by the object. Once an object is destroyed, it should not be used.

  ##### Throws:

  - DeveloperError : This object was destroyed, i.e., destroy() was called.

#### isDestroyed() → Boolean
DataSources/GeometryUpdater.js 217

  Returns true if this object was destroyed; otherwise, false.

  ##### Returns:

  True if this object was destroyed; otherwise, false.

#### isFilled(time) → Boolean
DataSources/GeometryUpdater.js 187

  Checks if the geometry is filled at the provided time.

  Name | Type | Description
  --- | --- | ---
  `time` | JulianDate | The time for which to retrieve visibility.

  ##### Returns:

  true if geometry is filled at the provided time, false otherwise.

#### isOutlineVisible(time) → Boolean
DataSources/GeometryUpdater.js 178

  Checks if the geometry is outlined at the provided time.

  Name | Type | Description
  --- | --- | ---
  `time` | JulianDate | The time for which to retrieve visibility.

  ##### Returns:

  true if geometry is outlined at the provided time, false otherwise.